---
title: What does an API reference need?
slug: MDN/Structures/API_references/What_does_an_API_reference_need
tags:
  - API
  - Reference
  - onboarding
  - page types
  - pages
---
<div>{{MDNSidebar}}</div><p class="summary">This article explains what pages are required for a complete API reference.</p>

<div class="note">
<p><strong>Note</strong>: It is a good idea to create the list of documents you need to write or update when you are working on an API reference, then check them off as you complete them.</p>
</div>

<h2 id="API_pages_at_a_glance">API pages at a glance</h2>

<p>An API reference will generally contain the following pages. You can find more details of what each page contains, examples, and templates, in our <a href="/en-US/docs/MDN/Contribute/Structures/Page_types">Page types</a> article.</p>

<ol>
 <li>Overview page</li>
 <li>Interface pages</li>
 <li>Constructor pages</li>
 <li>Method pages</li>
 <li>Property pages (including event handlers properties)</li>
 <li>Event pages</li>
 <li>Concept/guide pages</li>
 <li>Examples</li>
</ol>

<div class="note">
<p><strong>Note</strong>: We'll be referring to the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a> for examples in this article.</p>
</div>

<div class="note">
<p><strong>Note</strong>: To create a page as specified below, the easiest way is to go to the parent page you want it to hang off, and choose <em>Cog icon &gt; New sub-article</em>. If you haven't got this option available on your MDN interface, you'll need to request this privilege (ask at <code>mdn-admins@mozilla.org</code>), or ask another MDN contributor to create them for you.</p>
</div>

<h3 id="Overview_pages">Overview pages</h3>

<p>A single API overview page is used to describe the role of the API, its top-level interfaces, related features contained in other interfaces, and other high level details. Its name and slug should be the name of the API plus "API" on the end. It is placed at the top level of the API reference, as a child of <a href="/en-US/docs/Web/API">https://developer.mozilla.org/en-US/docs/Web/API</a>.</p>

<p>Example:</p>

<ul>
 <li>Title: <em>Web Audio API</em></li>
 <li>Slug: <em>Web_Audio_API</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/Web_Audio_API">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API</a></li>
</ul>

<h3 id="Interface_pages">Interface pages</h3>

<p>Each interface will have its own page too, describing the purpose of the interface, listing any members (constructors, methods, properties, etc. it contains), and showing what browsers it is compatible with. A page's name and slug should be the name of the interface, exactly as written in the spec. Each page is placed at the top level of the API reference, as a child of <a href="/en-US/docs/Web/API">https://developer.mozilla.org/en-US/docs/Web/API</a>.</p>

<p>Examples:</p>

<ul>
 <li>Title: <em>AudioContext</em></li>
 <li>Slug: <em>AudioContext</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext</a></li>
</ul>

<ul>
 <li>Title: <em>AudioNode</em></li>
 <li>Slug: <em>AudioNode</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioNode">https://developer.mozilla.org/en-US/docs/Web/API/AudioNode</a></li>
</ul>

<div class="note">
<p><strong>Note:</strong> We document every member appearing in the interface. You should bear the following rules in mind:</p>

<ul>
 <li>We document methods defined on the <u>prototype</u> of an object implementing this interface (instance methods), and methods defined on the actual class itself (static methods). On the rare occasions that they both exist on the same interface, you should list them in separate sections on the page (Static methods/Instance methods). Usually only instance methods exist, in which case you can put these under the title "Methods".</li>
 <li>We do not document inherited properties and methods of the interface: they are listed on the respective parent interface. We do hint at their existence though.</li>
 <li>We do document properties and methods defined in mixins, though we use the mixin name as interface name. (This is not optimal as the mixin name will not appear in the console, but it prevents the duplication of documentation. We may revisit this in the future.)</li>
 <li>Special methods like the stringfier (<code>toString()</code>) and the jsonizier (<code>toJSON()</code>) are also listed if they do exist.</li>
 <li>Named constructors (like <code>Image()</code>  for {{domxref("HTMLImageElement")}} ) are also listed, if relevant.</li>
</ul>
</div>

<h3 id="Constructor_pages">Constructor pages</h3>

<p>Each interface has 0 or 1 constructors, documented on a subpage of the interface's page. It describes the purpose of the constructor and shows what its syntax looks like, usage examples, browser compatibility information, etc. Its slug is the name of the constructor, which is exactly the same as the interface name, and the title is interface name, dot, constructor name, then parentheses on the end.</p>

<p>Example:</p>

<ul>
 <li>Title: <em>AudioContext.AudioContext()</em></li>
 <li>Slug: <em>AudioContext</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext/AudioContext">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext/AudioContext</a></li>
</ul>

<h3 id="Property_pages">Property pages</h3>

<p>Each interface has zero or more properties, documented on subpages of the interface's page. each page describes the purpose of the property and shows what its syntax looks like, usage examples, browser compatibility information, etc. Its slug is the name of the property, and the title is interface name, dot, then property name.</p>

<p>Examples:</p>

<ul>
 <li>Title: <em>AudioContext.state</em></li>
 <li>Slug: <em>state</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext/state">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext/state</a></li>
</ul>

<ul>
 <li>Title: <em>AudioContext.onstatechange</em></li>
 <li>Slug: <em>onstatechange</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext/onstatechange">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext/onstatechange</a></li>
</ul>

<div class="note">
<p><strong>Note:</strong> Event handler properties are treated in the same way as regular properties; they are generally listed in a separate section on the interface page though.</p>
</div>

<ul>
</ul>

<h3 id="Method_pages">Method pages</h3>

<p>Each interface has zero or more methods, documented on subpages of the interface's page. each page describes the purpose of the method and shows what its syntax looks like, usage examples, browser compatibility information, etc. Its slug is the name of the method, and the title is interface name, dot, method name, then parentheses.</p>

<p>Examples:</p>

<ul>
 <li>Title: <em>AudioContext.close()</em></li>
 <li>Slug: <em>close</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext/close">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext/close</a></li>
</ul>

<ul>
 <li>Title: <em>AudioContext.createGain()</em></li>
 <li>Slug: <em>createGain</em></li>
 <li>URL: <a href="/en-US/docs/Web/API/AudioContext/createGain">https://developer.mozilla.org/en-US/docs/Web/API/AudioContext/createGain</a></li>
</ul>

<h3 id="Event_pages">Event pages</h3>

<p>Each event handler property you create will have a corresponding event page, describing the event that causes the handler to fire, documented on a subpage of <a href="/en-US/docs/Web/Events">https://developer.mozilla.org/en-US/docs/Web/Events</a>. Each page describes the purpose of the event and shows what its syntax looks like, usage examples, browser compatibility information, etc. Its slug and title is the name of the event.</p>

<p>Example:</p>

<ul>
 <li>Title: <em>statechange</em></li>
 <li>Slug: <em>statechange</em></li>
 <li>URL: <a href="/en-US/docs/Web/Events/statechange">https://developer.mozilla.org/en-US/docs/Web/Events/statechange</a></li>
</ul>

<h3 id="Conceptguide_pages">Concept/guide pages</h3>

<p>Most API references have at least one guide and sometimes also a concept page to accompany it. At minimum, an API reference should contain a guide called "Using the <em>name-of-api</em>", which will provide a basic guide to how to use the API. More complex APIs may require multiple usage guides to explain how to use different aspects of the API.</p>

<p>If required, you can also including a concepts article called "<em>name-of-api</em> concepts", which will provide explanation of the theory behind any concepts related to the API that developers should understand to effectively use it.</p>

<p>These articles should all be created as subpages of the API overview page. For example, the Web Audio has four guides and a concept article:</p>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Visualizations_with_Web_Audio_API">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Visualizations_with_Web_Audio_API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialization_basics">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialization_basics</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Porting_webkitAudioContext_code_to_standards_based_AudioContext">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Porting_webkitAudioContext_code_to_standards_based_AudioContext</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API">https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API</a></li>
</ul>

<h3 id="Examples">Examples</h3>

<p>You should create some examples that demonstrate at least the most common use cases of the API. You can put these anywhere that is appropriate, although the recommended place is the <a href="https://github.com/mdn/">MDN GitHub repo</a>.</p>
